OpenTTD Source: VideoDriver_Win32GDI Class Reference

OpenTTD Source 13.1

Public Member Functions | Protected Member Functions | Protected Attributes
VideoDriver_Win32GDI Class Reference

The GDI video driver for windows. More...

`#include <win32_v.h>`

Inheritance diagram for VideoDriver_Win32GDI:

## Public Member Functions
const char * | Start (const StringList &param) override
| Start this driver. More...
void | Stop () override
| Stop this driver.
bool | AfterBlitterChange () override
| Callback invoked after the blitter was changed. More...
const char * | GetName () const override
| Get the name of this driver. More...
Public Member Functions inherited from VideoDriver_Win32Base
void | MakeDirty (int left, int top, int width, int height) override
| Mark a particular area dirty. More...
void | MainLoop () override
| Perform the actual drawing.
bool | ChangeResolution (int w, int h) override
| Change the resolution of the window. More...
bool | ToggleFullscreen (bool fullscreen) override
| Change the full screen setting. More...
bool | ClaimMousePointer () override
void | EditBoxLostFocus () override
| An edit box lost the input focus. More...
std::vector< int > | GetListOfMonitorRefreshRates () override
| Get a list of refresh rates of each available monitor. More...
Public Member Functions inherited from VideoDriver
virtual void | ToggleVsync (bool vsync)
| Change the vsync setting. More...
virtual bool | UseSystemCursor ()
| Get whether the mouse cursor is drawn by the video driver. More...
virtual void | PopulateSystemSprites ()
| Populate all sprites in cache.
virtual void | ClearSystemSprites ()
| Clear all cached sprites.
virtual bool | HasGUI () const
| Whether the driver has a graphical user interface with the end user. More...
virtual bool | HasEfficient8Bpp () const
| Has this video driver an efficient code path for palette animated 8-bpp sprites? More...
virtual bool | HasAnimBuffer ()
| Does this video driver support a separate animation buffer in addition to the colour buffer? More...
virtual uint8 * | GetAnimBuffer ()
| Get a pointer to the animation buffer of the video back-end. More...
virtual void | EditBoxGainedFocus ()
| An edit box gained the input focus.
virtual int | GetSuggestedUIScale ()
| Get a suggested default GUI scale taking screen DPI into account.
virtual const char * | GetInfoString () const
void | QueueOnMainThread (std::function< void()> &&func)
| Queue a function to be called on the main thread with game state lock held and video buffer locked. More...
void | GameLoopPause ()
| Pause the game-loop for a bit, releasing the game-state lock. More...

## Protected Member Functions
void | Paint () override
| Paint the window.
void * | GetVideoPointer () override
| Get a pointer to the video buffer.
bool | AllocateBackingStore (int w, int h, bool force=false) override
| (Re-)create the backing store.
void | PaletteChanged (HWND hWnd) override
| Palette of the window has changed.
void | MakePalette ()
void | UpdatePalette (HDC dc, uint start, uint count)
Protected Member Functions inherited from VideoDriver_Win32Base
Dimension | GetScreenSize () const override
| Get the resolution of the main screen.
float | GetDPIScale () override
| Get DPI scaling factor of the screen OTTD is displayed on. More...
void | InputLoop () override
| Handle input logic, is CTRL pressed, should we fast-forward, etc.
bool | LockVideoBuffer () override
| Make sure the video buffer is ready for drawing. More...
void | UnlockVideoBuffer () override
| Unlock a previously locked video buffer.
void | CheckPaletteAnim () override
| Process any pending palette animation.
bool | PollEvent () override
| Process a single system event. More...
void | Initialize ()
bool | MakeWindow (bool full_screen, bool resize=true)
| Instantiate a new window. More...
void | ClientSizeChanged (int w, int h, bool force=false)
virtual uint8 | GetFullscreenBpp ()
| Get screen depth to use for fullscreen mode. More...
virtual void | ReleaseVideoPointer ()
| Hand video buffer back to the painting backend.
Protected Member Functions inherited from VideoDriver
void | UpdateAutoResolution ()
| Apply resolution auto-detection and clamp to sensible defaults.
void | StartGameThread ()
| Start the loop for game-tick.
void | StopGameThread ()
| Stop the loop for the game-tick. More...
void | Tick ()
| Give the video-driver a tick. More...
void | SleepTillNextTick ()
| Sleep till the next tick is about to happen.
std::chrono::steady_clock::duration | GetGameInterval ()
std::chrono::steady_clock::duration | GetDrawInterval ()
void | DrainCommandQueue ()
| Execute all queued commands.

## Protected Attributes
HBITMAP | dib_sect
| System bitmap object referencing our rendering buffer.
HPALETTE | gdi_palette
| Palette object for 8bpp blitter.
void * | buffer_bits
| Internal rendering buffer.
Protected Attributes inherited from VideoDriver_Win32Base
HWND | main_wnd
| Handle to system window.
bool | fullscreen
| Whether to use (true) fullscreen mode.
bool | has_focus = false
| Does our window have system focus?
Rect | dirty_rect
| Region of the screen that needs redrawing.
int | width = 0
| Width in pixels of our display surface.
int | height = 0
| Height in pixels of our display surface.
int | width_org = 0
| Original monitor resolution width, before we changed it.
int | height_org = 0
| Original monitor resolution height, before we changed it.
bool | buffer_locked
| Video buffer was locked by the main thread.
Protected Attributes inherited from VideoDriver
const uint | ALLOWED_DRIFT = 5
| How many times videodriver can miss deadlines without it being overly compensated.
std::chrono::steady_clock::time_point | next_game_tick
std::chrono::steady_clock::time_point | next_draw_tick
bool | fast_forward_key_pressed
| The fast-forward key is being pressed.
bool | fast_forward_via_key
| The fast-forward was enabled by key press.
bool | is_game_threaded
std::thread | game_thread
std::mutex | game_state_mutex
std::mutex | game_thread_wait_mutex

## Additional Inherited Members
Public Types inherited from Driver
enum | Type { DT_BEGIN = 0, DT_MUSIC = 0, DT_SOUND, DT_VIDEO, DT_END }
| The type of driver. More...
Static Public Member Functions inherited from VideoDriver
static VideoDriver * | GetInstance ()
| Get the currently active instance of the video driver.
Static Protected Member Functions inherited from VideoDriver
static void | GameThreadThunk (VideoDriver *drv)

## Detailed Description

The GDI video driver for windows.

Definition at line 77 of file win32_v.h.

## Member Function Documentation

## ◆ AfterBlitterChange()

bool VideoDriver_Win32GDI::AfterBlitterChange | ( |  | ) |
| overridevirtual

Callback invoked after the blitter was changed.

Returns
  True if no error.

Reimplemented from VideoDriver.

Definition at line 1089 of file win32_v.cpp.

References AllocateBackingStore(), and BlitterFactory::GetCurrentBlitter().

## ◆ GetName()

const char* VideoDriver_Win32GDI::GetName | ( |  | ) | const
| inlineoverridevirtual

Get the name of this driver.

Returns
  The name of the driver.

Implements Driver.

Definition at line 87 of file win32_v.h.

## ◆ Start()

const char * VideoDriver_Win32GDI::Start | ( | const StringList & | parm | ) |
| overridevirtual

Start this driver.

Parameters

  parm | Parameters passed to the driver.

Returns
  nullptr if everything went okay, otherwise an error message.

Implements Driver.

Definition at line 1029 of file win32_v.cpp.

References _cur_resolution, AllocateBackingStore(), BlitterFactory::GetCurrentBlitter(), and VideoDriver_Win32Base::MakeWindow().

The documentation for this class was generated from the following files:

- src/video/win32_v.h
- src/video/win32_v.cpp